#include "UART1.h"

/*************  UART1 发送、接收寄存器  **************/
u8 xdata DMABufferTX1[64];
u8 xdata DMABufferRX1[64];


u8 kkkk = 0;





bit UART_TX_buy = 0;



//========================================================================
//
//		UART1超时变量
//
//========================================================================
u8 RX1_num_old = 0;
u8 RX1_Cnt_num = 0;



void UART1_DMA_Config(void)
{
    P_SW2 |= 0x80;
    DMA_UR1T_CFG = 0x80; 							// bit7 1:启用中断
    DMA_UR1T_STA = 0x00;							//清空中断
    DMA_UR1T_AMT = 63; 								// 自动发送字节数 = n+1
    DMA_UR1T_TXAH = (u8)((u16)&DMABufferTX1 >> 8);
    DMA_UR1T_TXAL = (u8)((u16)&DMABufferTX1);
    DMA_UR1T_CR = 0x80;

    DMA_UR1R_CFG = 0x80; 							// bit7 1:启用中断
    DMA_UR1R_STA = 0x00; 							//清空中断
    DMA_UR1R_AMT = 63; 								// 自动接收字节数 = n+1
    DMA_UR1R_RXAH = (u8)((u16)&DMABufferRX1 >> 8);
    DMA_UR1R_RXAL = (u8)((u16)&DMABufferRX1);

    DMA_UR1R_CR = 0xa1; 							// 自动接收
}







void UART1_config()
{
    TR1 = 0;
    AUXR &= ~0x01;	   // S1 BRT Use Timer1;
    AUXR |= (1 << 6);  // Timer1 set as 1T mode
    TMOD &= ~(1 << 6); // Timer1 set As Timer
    TMOD &= ~0x30;	   // Timer1_16bitAutoReload;
    TH1 = (u8)((65536UL - (MAIN_Fosc / 4) / Baudrate1) / 256);
    TL1 = (u8)((65536UL - (MAIN_Fosc / 4) / Baudrate1) % 256);
    ET1 = 0;		  
    INTCLKO &= ~0x02; 
    TR1 = 1;
    SCON = (SCON & 0x3f) | 0x40; // UART1ģʽ, 0x00: ͬҽӆλˤԶ, 0x40: 8λ˽ߝ,ࠉҤҨ͘Ê, 0x80: 9λ˽ߝ,ڌ֨Ҩ͘Ê, 0xc0: 9λ˽ߝ,ࠉҤҨ͘Ê

    REN = 1; 
    P_SW1 &= 0x3f;
    P_SW1 |= 0x40; // UART1 switch to, 0x00: P3.0 P3.1, 0x40: P3.6 P3.7, 0x80: P1.6 P1.7, 0xC0: P4.3 P4.4
}






void UART1_TX(u16 num)
{
    if(num)
    {
        UART_TX_buy = 1;
        num = num-1;
        DMA_UR1T_AMT = (u8)(num);
        DMA_UR1T_CR = 0xc0;
    }
}






void UART1_TDMA()  interrupt DMA_UR1T_VECTOR
{
    if (DMA_UR1T_STA & 0x01)	//发送完成
    {
        DMA_UR1T_STA &= ~0x01;
        UART_TX_buy = 0;

    }
    if (DMA_UR1T_STA & 0x04)	//数据覆盖
    {
        DMA_UR1T_STA &= ~0x04;
    }

}


void UART1_RDMA()  interrupt DMA_UR1R_VECTOR
{

    if (DMA_UR1R_STA & 0x01)	//接收完成
    {
        DMA_UR1R_STA &= ~0x01;
        DMA_UR1R_CR = 0x00;
        DMA_UR1R_CR = 0xa1;
        RX1_Cnt_num = 0;
        RX1_num_old	= 0;
    }
    if (DMA_UR1R_STA & 0x02)	//数据丢弃
    {
        DMA_UR1R_STA &= ~0x02;
    }
}









void UART1_bit(u8 dat)
{
    DMA_UR1T_AMT = 0;
    DMABufferTX1[0]  = dat;
    DMA_UR1T_CR = 0xc0;
}

void UART2_bit(u16 dat)
{

    while(UART_TX_buy);
    DMA_UR1T_AMT = 1;
    DMABufferTX1[0]  = dat>>8;
    DMABufferTX1[1]  = dat;
    DMA_UR1T_CR = 0xc0;
    UART_TX_buy = 1;
}


void UART8_bit(u16 dat,u16 dat1,u16 dat2,u16 dat3)
{

    while(UART_TX_buy);
    DMA_UR1T_AMT = 7;
    DMABufferTX1[0]  = dat>>8;
    DMABufferTX1[1]  = dat;

    DMABufferTX1[2]  = dat1>>8;
    DMABufferTX1[3]  = dat1;

    DMABufferTX1[4]  = dat2>>8;
    DMABufferTX1[5]  = dat2;

    DMABufferTX1[6]  = dat3>>8;
    DMABufferTX1[7]  = dat3;

    DMA_UR1T_CR = 0xc0;
    UART_TX_buy = 1;
}



//========================================================================
// 函数: u8 UART1_OverTime()
// 描述: 串口1 DMA 超时处理函数，如果没有检测到超时或者小于最小接收数量，均返回0
// 参数: none.
// 返回: 接受到的数据字节数
// 版本: VER1.0
// 日期: 2023-9-1
// 备注:
//========================================================================
u8 UART1_OverTime()
{
    u8 ed_num = 0;
    if(DMA_UR1R_DONE!=0)               	                  //DAM接收数据个数寄存器不为0，认为正在接收，或者已经接收完了
    {
        if(RX1_num_old != DMA_UR1R_DONE)               	  //判断历史接收数量RX1_num_old的字节接收数是否与现在的字节接收数量DMA_UR1R_DONE相等，不相等则认为数据还在继续接收
        {
            RX1_Cnt_num = 0;                              //超时计时  = 0
            RX1_num_old = DMA_UR1R_DONE;			            //历史接收数量RX1_num_old = 现在的字节接收数量DMA_UR1R_DONE,更新历史数量;
        }
        else
        {
            RX1_Cnt_num++;			                          //如果历史接收数量RX1_num_old = 现在的字节接收数量DMA_UR1R_DONE ，则认为接收停止，开始超时计时;
        }
        if(RX1_Cnt_num > UART1_OverTime_num)	            //超时计数 > 超时设定时间
        {
            RX1_Cnt_num = 0;	                            //超时计数清零
            RX1_num_old	= 0;	                            //历史接收数量清零
            if(DMA_UR1R_DONE >= UART1_Min_num)            //如果接收数量大于等于最小接收数量
            {
//							  if(DMABufferRX1[1] == 0x06)               //而且第二位数据为0x06
//                {
//									  if((DMA_UR1R_DONE % 2) == 0)          //而且数据长度为双数
//                    {
//                        ed_num = DMA_UR1R_DONE;           //返回数据数量
//                    }
//                }
//                else if(DMABufferRX1[1] == 0x03)          //如果第二位数据为0x03
//                {
//                    if(DMA_UR1R_DONE  == 8)               //而且数据长度 = 8
//                    {
//                        ed_num = DMA_UR1R_DONE;           //返回数据数量
//                    }
//                }
                ed_num = DMA_UR1R_DONE;                   //返回数据数量
            }
            DMA_UR1R_CR = 0x00;                           //清空DMA_UR1R_DONE（1/2）
            DMA_UR1R_CR = 0xa1;                           //清空DMA_UR1R_DONE（2/2）
        }
    }
    return ed_num;
}










