#include "stc.h"
#include "timer.h"
#include "UART1.h"


#define TM_1MS      (65536 - MAIN_Fosc/1000)

BOOL f1ms;

/*************  系统节拍  **************/
u16 CLOCK = 0;//定时计数
u16 CLOCK_flag = 0;//节拍标志位
//*****************************************************
//0bit:10ms
//1bit:20ms
//2bit:50ms
//3bit:100ms
//4bit:200ms
//5bit:500ms
//6bit:1000ms

//*****************************************************


void delay_ms(u8 ms)
{
    u16 i;
    do {
        i = MAIN_Fosc / 10000;
        while(--i);
    } while(--ms);
}



void timer_init()
{
    f1ms = 0;
    AUXR |= 0x80;
    TMOD &= ~0x0f;
    TL0 = TM_1MS;
    TH0 = TM_1MS >> 8;
    TR0 = 1;
    ET0 = 1;
}


//========================================================================
// 函数: System_beat()
// 描述: 计算系统节拍
// 参数: none.
// 返回: none.
// 版本: VER1.0
// 日期: 2023-9-1
// 备注:
//========================================================================

void System_beat()
{



    CLOCK++;
    if(CLOCK % 10 == 0)
    {
        CLOCK_flag |= 0x0001;
    }
    if(CLOCK % 20 == 0)
    {
        CLOCK_flag |= 0x0002;
    }
    if(CLOCK % 50 == 0)
    {
        CLOCK_flag |= 0x0004;

    }
    if(CLOCK % 100 == 0)
    {
        CLOCK_flag |= 0x0008;
    }
    if(CLOCK % 200 == 0)
    {
        CLOCK_flag |= 0x0010;
    }
    if(CLOCK % 500 == 0)
    {
        CLOCK_flag |= 0x0020;
    }
    if(CLOCK > 1000)
    {
        CLOCK_flag |= 0x0040;
        CLOCK = 0;
    }

}




//========================================================================
// 函数: System_beat_execution()
// 描述: 系统节拍执行
// 参数: none.
// 返回: none.
// 版本: VER1.0
// 日期: 2023-9-1
// 备注:
//========================================================================

void System_beat_execution()
{

    if(CLOCK_flag & 0x0001)
    {
        CLOCK_flag &= ~0x0001;
    }
    if(CLOCK_flag & 0x0002)
    {

        CLOCK_flag &= ~0x0002;
    }
    if(CLOCK_flag & 0x0004)
    {
        CLOCK_flag &= ~0x0004;
    }
    if(CLOCK_flag & 0x0008)
    {
        CLOCK_flag &= ~0x0008;
    }
    if(CLOCK_flag & 0x0010)
    {

        CLOCK_flag &= ~0x0010;
    }
    if(CLOCK_flag & 0x00020)
    {

        
        CLOCK_flag &= ~0x00020;
    }
    if(CLOCK_flag & 0x00040)
    {

        UART1_bit(kkkk);
//			  UART1_TX(64);
        CLOCK_flag &= ~0x00040;
    }
}











void timer0_isr() interrupt 1
{
    f1ms = 1;
	
	  System_beat();
	
	
	
	
	
	
	
}
