#include "stc.h"
#include "usb_desc.h"

u8 code DEVICEDESC[18] =
{
    0x12,                   //bLength(18);
    0x01,                   //bDescriptorType(Device);
    0x10,0x01,              //bcdUSB(2.00);
    0x00,                   //bDeviceClass(0);
    0x00,                   //bDeviceSubClass0);
    0x00,                   //bDeviceProtocol(0);
    0x08,                   //bMaxPacketSize0(64);
	  0x86,
	  0x1A,
		0x29,
	  0xE1,  
	  0x01, 
	  0x35, 
	  0x01, 
	  0x02,
	  0x03,
	  0x01,
};







u8 code CONFIGDESC[116] =
{
    0x09,                   //bLength(9);
    0x02,                   //bDescriptorType(Configuration);
    0x74,0x00,              //wTotalLength(41);
    0x04,                   //bNumInterfaces(1);
    0x01,                   //bConfigurationValue(1);
    0x00,                   //iConfiguration(0);
    0xa0,                   //bmAttributes(BUSPower+Remote Wakeup);
    0x32,                   //MaxPower(100mA);

    0x09,                   //bLength(9);
    0x04,                   //bDescriptorType(Interface);
    0x00,                   //bInterfaceNumber(0);
    0x00,                   //bAlternateSetting(0);
    0x01,                   //bNumEndpoints(2);
    0x03,                   //bInterfaceClass(HID);
    0x01,                   //bInterfaceSubClass(Boot);
    0x01,                   //bInterfaceProtocol(Keyboard);
    0x00,                   //iInterface(0);

    0x09,                   //bLength(9);
    0x21,                   //bDescriptorType(HID);
    0x10,0x01,              //bcdHID(1.01);
    0x00,                   //bCountryCode(0);
    0x01,                   //bNumDescriptors(1);
    0x22,                   //bDescriptorType(HID Report);
    0x41,0x00,              //wDescriptorLength(131);

    0x07,                   //bLength(7);
    0x05,                   //bDescriptorType(Endpoint);
    0x81,                   //bEndpointAddress(EndPoint1 as IN);
    0x03,                   //bmAttributes(Interrupt);
    0x08,0x00,              //wMaxPacketSize(8);
    0x02,                   //bInterval(10ms);

    0x09,                   //bLength(7);
    0x04,                   //bDescriptorType(Endpoint);
    0x01,                   //bEndpointAddress(EndPoint1 as OUT);
    0x00,                   //bmAttributes(Interrupt);
    0x01,0x03,              //wMaxPacketSize(1);
    0x00,                   //bInterval(10ms);
		
		
		0x00,
		0x00,
		0x09,
		0x21,
		0x10,
		0x01,
		0x00,
		
		0x01,
		0x22,
		0x65,
		0x00,
		0x07,
		0x05,
		0x83,
		0x03,
		
		0x08,
		0x00,
		0x0A,
		0x09,
		0x04,
		0x02,
		0x00,
		0x01,
		
		0x03,
		0x01,
		0x02,
		0x00,
		0x09,
		0x21,
		0x10,
		0x01,
		
		0x00,
		0x01,
		0x22,
		0x98,
		0x00,
		0x07,
		0x05,
		0x82,
		
		0x03,
		0x08,
		0x00,
		0x02,
		0x09,
		0x04,
		0x03,
		0x00,
		
		0x02,
		0x03,
		0x00,
		0x00,
		0x00,
		0x09,
		0x21,
		0x00,
		
		0x01,
		0x00,
		0x01,
		0x22,
		0x25,
		0x00,
		0x07,
		0x05,
		
		0x84,
		0x03,
		0x40,
		0x00,
		0x01,
		0x07,
		0x05,
		0x04,
		
		0x03,		
		0x40,		
		0x00,
		0x01,

};






u8 code TEXT_1[26] =
{
		0x1A,		
		0x03,		
		0x32,
		0x00,
		0x30,		
		0x00,		
		0x31,
		0x00,

		0x39,		
		0x00,		
		0x35,
		0x00,
		0x39,		
		0x00,		
		0x35,
		0x00,

		0x32,		
		0x00,		
		0x31,
		0x00,
		0x42,		
		0x00,		
		0x46,
		0x00,
	
		0x31,
		0x00,
};











/*
Input Report:
0   ID(1)
1   Modifierkeys (D0:LCtrl D1:LShift D2:LAlt D3:LGui D4:RCtrl D5:RShift D6:RAlt D7:RGui)
2	Reserved
3	Keycode 1
4	Keycode 2
5	Keycode 3
6	Keycode 4
7	Keycode 5
8	Keycode 6

0   ID(2)
1   KeyCode(L)
2   KeyCode(H)
3	Reserved
4	Reserved
5	Reserved
6	Reserved
7	Reserved
8	Reserved

0   ID(3)
1   System (D0:PowerDown D1:Sleep D2:Wakeup D3~D7:Reserved)
2   Reserved
3	Reserved
4	Reserved
5	Reserved
6	Reserved
7	Reserved
8	Reserved

Output Report:
0   ID(1)
1   LEDs (D0:NumLock D1:CapLock D2:ScrollLock)
*/
u8 code HIDREPORTDESC[65] =
{
 		0x05,		
		0x01,		
		0x09,
		0x06,
		0xA1,		
		0x01,		
		0x05,
		0x07,
	
 		0x19,		
		0xE0,		
		0x29,
		0xE7,
		0x15,		
		0x00,		
		0x25,
		0x01,	
	
 		0x75,		
		0x01,		
		0x95,
		0x08,
		0x81,		
		0x02,		
		0x95,
		0x01,	
	
 		0x75,		
		0x08,		
		0x81,
		0x01,
		0x95,		
		0x03,		
		0x75,
		0x01,
	
 		0x05,		
		0x08,		
		0x19,
		0x01,
		0x29,		
		0x03,		
		0x91,
		0x02,

 		0x95,		
		0x01,		
		0x75,
		0x05,
		0x91,		
		0x01,		
		0x95,
		0x06,
		
 		0x75,		
		0x08,		
		0x15,
		0x00,
		0x26,		
		0xFF,		
		0x00,
		0x05,	
		
 		0x07,		
		0x19,		
		0x00,
		0x2A,
		0xFF,		
		0x00,		
		0x81,
		0x00,
		
		0xC0,
		
};


u8 code TEXT_2[101] =
{
 		0x05,		
		0x01,		
		0x09,
		0x80,
		0xA1,		
		0x01,		
		0x85,
		0x01,

		0x19,		
		0x81,		
		0x29,
		0x83,
		0x15,		
		0x00,		
		0x25,
		0x01,	

 		0x95,		
		0x03,		
		0x75,
		0x01,
		0x81,		
		0x02,		
		0x95,
		0x01,	
	
 		0x75,		
		0x05,		
		0x81,
		0x01,
		0xC0,		
		0x05,		
		0x0C,
		0x09,	
	
 		0x01,		
		0xA1,		
		0x01,
		0x85,
		0x02,		
		0x15,		
		0x00,
		0x25,	
	
 		0x01,		
		0x09,		
		0xE9,
		0x09,
		0xEA,		
		0x09,		
		0xE2,
		0x09,	

 		0xCD,		
		0x19,		
		0xB5,
		0x29,
		0xB8,		
		0x75,		
		0x01,
		0x95,	

 		0x08,		
		0x81,		
		0x02,
		0x0A,
		0x8A,		
		0x01,		
		0x0A,
		0x21,	

 		0x02,		
		0x0A,		
		0x2A,
		0x02,
		0x1A,		
		0x23,		
		0x02,
		0x2A,	

 		0x27,		
		0x02,		
		0x81,
		0x02,
		0x0A,		
		0x83,		
		0x01,
		0x0A,	

 		0x96,		
		0x01,		
		0x0A,
		0x92,
		0x01,		
		0x0A,		
		0x9E,
		0x01,	
		
 		0x0A,		
		0x94,		
		0x01,
		0x0A,
		0x06,		
		0x02,		
		0x09,
		0xB2,	

 		0x09,		
		0xB4,		
		0x81,
		0x02,
		0xC0,		


	
};


u8 code TEXT_3[152] =
{
 		0x05, 0x01, 0x09, 0x02, 0xA1, 0x01, 0x85, 0x01,
 		0x05, 0x09, 0x19, 0x01, 0x29, 0x05, 0x15, 0x00,
 		0x25, 0x01, 0x95, 0x05, 0x75, 0x01, 0x81, 0x02,
	  0x95, 0x01, 0x75, 0x03, 0x81, 0x03, 0x05, 0x01,
	  0x09, 0x01, 0xa1, 0x00, 0x09, 0x30, 0x09, 0x31,
	  0x15, 0x81, 0x25, 0x7f, 0x75, 0x08, 0x95, 0x02,
  	0x81, 0x06, 0xc0, 0x09, 0x38, 0x15, 0x81, 0x25,
  	0x7f, 0x75, 0x08, 0x95, 0x01, 0x81, 0x06, 0xc0,
  	0x05, 0x01, 0x09, 0x02, 0xa1, 0x01, 0x09, 0x01,
  	0xa1, 0x00, 0x85, 0x02, 0x05, 0x09, 0x19, 0x01,
	  0x29, 0x05, 0x15, 0x00, 0x25, 0x01, 0x95, 0x05,
	  0x75, 0x01, 0x81, 0x02, 0x95, 0x01, 0x75, 0x03,
  	0x81, 0x03, 0x05, 0x01, 0x09, 0x30, 0x15, 0x00,
	  0x26, 0xff, 0x0f, 0x75, 0x0d, 0x95, 0x01, 0x81,
	  0x02, 0x75, 0x03, 0x95, 0x01, 0x81, 0x03, 0x09,
	  0x31, 0x15, 0x00, 0x26, 0xff, 0x0f, 0x75, 0x0d,
	  0x95, 0x01, 0x81, 0x02, 0x75, 0x03, 0x95, 0x01,
	  0x81, 0x03, 0x09, 0x38, 0x15, 0x81, 0x25, 0x7f,
  	0x75, 0x08, 0x95, 0x01, 0x81, 0x06, 0xc0, 0xc0,
};


u8 code TEXT_4[37] =
{

	0x06, 0xa0, 0xff, 0x09, 0x01, 0xa1, 0x01, 0x09,
	0x01, 0x15, 0x00, 0x26, 0xff, 0x00, 0x75, 0x08,
	0x95, 0x40, 0x81, 0x02, 0x09, 0x02, 0x75, 0x08,
	0x95, 0x40, 0x91, 0x02, 0x09, 0x03, 0x75, 0x08,
	0x95, 0x40, 0xb1, 0x02, 0xc0,
	
};

	




u8 code LANGIDDESC[4] =
{
    0x04,0x03,
    0x09,0x04,
};

u8 code MANUFACTDESC[22] =
{
//    0x08,0x03,
//    'S',0,
//    'T',0,
//    'C',0,
	
		0x16,		
		0x03,		
		0x57,
		0x00,
		0x57,		
		0x00,		
		0x57,
		0x00,
	
		0x2E,		
		0x00,		
		0x57,
		0x00,
		0x43,		
		0x00,		
		0x48,
		0x00,
	
		0x2E,		
		0x00,		
		0x43,
		0x00,
		0x4E,		
		0x00,		


};

u8 code PRODUCTDESC[46] =
{
//    0x22,0x03,
//    'S',0,
//    'T',0,
//    'C',0,
//    ' ',0,
//    'U',0,
//    'S',0,
//    'B',0,
//    ' ',0,
//    'K',0,
//    'e',0,
//    'y',0,
//    'b',0,
//    'o',0,
//    'a',0,
//    'r',0,
//    'd',0,
	
		0x2E,		
		0x03,		
		0x57,
		0x00,
		0x43,		
		0x00,		
		0x48,
		0x00,
	
		0x20,		
		0x00,		
		0x55,
		0x00,
		0x41,		
		0x00,		
		0x52,
		0x00,
		
		0x54,		
		0x00,		
		0x20,
		0x00,
		0x54,		
		0x00,		
		0x4F,
		0x00,		
		
		
		0x20,		
		0x00,		
		0x4B,
		0x00,
		0x42,		
		0x00,		
		0x2D,
		0x00,	
		
		0x4D,		
		0x00,		
		0x53,
		0x00,
		0x5F,		
		0x00,		
		0x56,
		0x00,	
	
		0x31,		
		0x00,		
		0x2E,
		0x00,
		0x35,		
		0x00,		

	
	
};

u8 code PACKET0[2] = 
{
    0, 0,
};

u8 code PACKET1[2] = 
{
    1, 0,
};

u8 code PACKET2[2] = 
{
    2, 0,
};

